/// Namespace
var android = {};
android.selection = {};

var ELEMENT_NODE = 1;
var ATTRIBUTE_NODE = 2;
var TEXT_NODE = 3;
var DATA_SECTION_NODE = 4;

var myStartOffset = 0;
var myEndOffset = 0;

/* hight light*/
var hlKeyword = "";
var hlStartElementLen = 0;
var hlEndElementLen = 0;
var hlStartElement;
var hlEndElement;
var hlCurOffset = 0;
var hlStartOffset = 0;
var hlEndOffset = 0;


android.selection.selectionStartRange = null;
android.selection.selectionEndRange = null;


/** The last point touched by the user. { 'x': xPoint, 'y': yPoint } */
android.selection.lastTouchPoint = null;


/** 
 * Starts the touch and saves the given x and y coordinates as last touch point
 */
android.selection.startTouch = function(x, y){
	
	android.selection.lastTouchPoint = {'x': x, 'y': y};
	
};



/**
 *	Checks to see if there is a selection.
 *
 *	@return boolean
 */
android.selection.hasSelection = function(){
	return window.getSelection().toString().length > 0;
};


/**
 *	Clears the current selection.
 */
android.selection.clearSelection = function(){
	
	try{
		// if current selection clear it.
	   	var sel = window.getSelection();
	   	sel.removeAllRanges();
	}catch(err){
		window.TextSelection.jsError(err);
	}	
};


/**
 *	Handles the long touch action by selecting the last touched element.
 */
android.selection.longTouch = function() {

	try{
    
    	android.selection.clearSelection();
    	
    	
	   	// if current selection clear it.
	   	var sel = window.getSelection();
	   	
	   	var oneWordCaret = document.caretRangeFromPoint(android.selection.lastTouchPoint.x, android.selection.lastTouchPoint.y);
	   	oneWordCaret.expand("word");
			
	   	
	   	sel.addRange(oneWordCaret);
	   	
	   	var temp = sel.getRangeAt(0);
	   	
	   	android.selection.saveSelectionStart();
	   	android.selection.saveSelectionEnd();
	   	
	   	
	   	// Show the context menu in app
	   	android.selection.selectionChanged();
	   	//android.selection.selectBetweenHandles();
	   	
	 }
	 catch(err){
	 	window.TextSelection.jsError(err);
	 }
   	
};

/**
 * Tells the app to show the context menu. 
 */
android.selection.selectionChanged = function(){

	try{
	
		var sel = window.getSelection();
		if(!sel){
			return;
		}
		
		var range = sel.getRangeAt(0);
		
		
		// Add spans to the selection to get page offsets
		var selectionEnd = $("<span id=\"selectionEnd\"/>");
	    var selectionStart = $("<span id=\"selectionStart\"/>");
	    
		
		var startRange = document.createRange();
    	startRange.setStart(range.startContainer, range.startOffset);
    	startRange.insertNode(selectionStart[0]);
		
		
		var endRange = document.createRange();
    	endRange.setStart(range.endContainer, range.endOffset);
    	endRange.insertNode(selectionEnd[0]);
	    
	   	
	   	// Create the bounds json object for the selection
	   	var handleBounds = "{'left': " + selectionStart.offset().left + ", ";
	   	handleBounds += "'top': " + selectionStart.offset().top + ", ";
	   	handleBounds += "'right': " + selectionEnd.offset().left + ", ";
	   	handleBounds += "'bottom': " + selectionEnd.offset().top + "}";
	   	
	   	
	   	// Pull the spans
	   	selectionStart.remove();
	   	selectionEnd.remove();
	   	
	   	// Reset range
	   	sel.removeAllRanges();
	   	sel.addRange(range);
	   	
	   	// Menu bounds
	   	var rect = range.getBoundingClientRect();
	   	
	   	var menuBounds = "{'left': " + rect.left + ", ";
	   	menuBounds += "'top': " + rect.top + ", ";
	   	menuBounds += "'right': " + rect.right + ", ";
	   	menuBounds += "'bottom': " + rect.bottom + "}";
	   	
	   	// Rangy
	   	var rangyRange = android.selection.getRange();
	   	
	   	// Text to send to the selection
	   	var text = window.getSelection().toString();
	   	
	   	// Set the content width
	   	window.TextSelection.setContentWidth(document.body.clientWidth);
	   	
	   	// Tell the interface that the selection changed
	   	window.TextSelection.selectionChanged(rangyRange, text, handleBounds, menuBounds);
	}
	catch(err){
		window.TextSelection.jsError(err);
	}
};



android.selection.getRange = function() {
    var serializedRangeSelected = rangy.serializeSelection();
    var serializerModule = rangy.modules.Serializer;
    if (serializedRangeSelected != '') {
        if (rangy.supported && serializerModule && serializerModule.supported) {
            var beginingCurly = serializedRangeSelected.indexOf("{");
            serializedRangeSelected = serializedRangeSelected.substring(0, beginingCurly);
            return serializedRangeSelected;
        }
    }
}



/** 
 * Returns the last touch point as a readable string.
 */
android.selection.lastTouchPointString = function(){
	if(android.selection.lastTouchPoint == null)
		return "undefined";
		
	return "{" + android.selection.lastTouchPoint.x + "," + android.selection.lastTouchPoint.y + "}";
};



android.selection.saveSelectionStart = function(){
	try{

		// Save the starting point of the selection
	   	var sel = window.getSelection();
		var range = sel.getRangeAt(0);
		
		var saveRange = document.createRange();
		
		saveRange.setStart(range.startContainer, range.startOffset);
		
		//var node = saveRange.startContainer;
		//alert(node.nodeValue);
		android.selection.selectionStartRange = saveRange;
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

android.selection.saveSelectionEnd = function(){

	try{

		// Save the end point of the selection
	   	var sel = window.getSelection();
		var range = sel.getRangeAt(0);
		var saveRange = document.createRange();
		saveRange.setStart(range.endContainer, range.endOffset);
		
		//var node = saveRange.startContainer;
		//alert(node.nodeValue);
		android.selection.selectionEndRange = saveRange;
	}catch(err){
		window.TextSelection.jsError(err);
	}
	
};



/**
 * Sets the last caret position for the start handle.
 */
android.selection.setStartPos = function(x, y){
	
	try{
    	
		android.selection.selectionStartRange = document.caretRangeFromPoint(x, y);
		android.selection.selectBetweenHandles();
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

/**
 * Sets the last caret position for the end handle.
 */
android.selection.setEndPos = function(x, y){
	
	try{	
		android.selection.selectionEndRange = document.caretRangeFromPoint(x, y);
		
		android.selection.selectBetweenHandles();
	
	}catch(err){
		window.TextSelection.jsError(err);
	}

};

/**
 *	Selects all content between the two handles
 */
android.selection.selectBetweenHandles = function(){
	
	try{
		var startCaret = android.selection.selectionStartRange;
		var endCaret = android.selection.selectionEndRange;
		
		// If we have two carets, update the selection
		if (startCaret && endCaret) {
		
			// If end caret comes before start caret, need to flip
			if(startCaret.compareBoundaryPoints (Range.START_TO_END, endCaret) > 0){
				var temp = startCaret;
				startCaret = endCaret;
				endCaret = temp;
				
				android.selection.selectionStartRange = startCaret;
				android.selection.selectionEndRange = endCaret;
			}
			
			var range = document.createRange();

			range.setStart(startCaret.startContainer, startCaret.startOffset);
			range.setEnd(endCaret.startContainer, endCaret.startOffset);
			
			//range.execCommand('BackColor', false, '#c6e7e8');
			//range.execCommand('ForeColor', false, '#1b95a8');
			
			android.selection.clearSelection();
				
			//document.execCommand("backColor", false, "#ffffff");
			//document.execCommand("foreColor", false, "#ff0000");
				
			var selection = window.getSelection();
			selection.addRange(range);
	
			
			
		}
		
		android.selection.selectionChanged();
   	}
   	catch(err){
   		window.TextSelection.jsError(err);
   	}
};

/**
 * public method
 * 
 *
 */

android.selection.selectStartAndEndNodeValue = function(){
	try{
		var sel = window.getSelection();
		var range = sel.getRangeAt(0);
		var startNode = range.startContainer;
		
		var endNode = range.endContainer;
		
		//alert(endNode.nodeType + ":" + endNode.nodeName + ":" + endNode.nodeValue);
		var startElement = android.selection.getParentElement(startNode);
		var endElement = android.selection.getParentElement(endNode);
		//alert(android.selection.getElementString(startElement));
		//alert(android.selection.getElementString(endElement));
		
		
		myStartOffset = 0;
		myEndOffset = 0;
		android.selection.getStartOffset(startElement, startNode);
		android.selection.getEndOffset(endElement, endNode);
		window.TextSelection.setStartAndEndNodeValue(android.selection.getElementString(startElement), android.selection.getElementString(endElement), myStartOffset, myEndOffset);
		//alert(endOffset);
		
		// high light here
		var span = document.createElement("span");
		span.setAttribute("class","SocialHighlight");
        span.style.backgroundColor="#ffcc99";
        span.style.color="#663300";
        range.surroundContents(span);
        
	}catch(err){
		window.TextSelection.jsError(err);
	}
	
};

/**
 * private method
 * according to the node, we get its parent node (the node should be the element type)
 *
 */
android.selection.getParentElement = function(node){
	for(var i=0; i<20; i++) {
		if(node.nodeType == 1 && node.nodeName.toUpperCase() != "BODY" && node.nodeName.toUpperCase() != "HEAD")
			return node;
		node = node.parentNode;
	}
};

/**
 * private method
 * 
 * get String of a element
 *
 * return the value of a element
 */
 
android.selection.getElementString = function(e){
	var eString="";
	e=e.childNodes || e;
	for(var i=0;i<e.length;i++){
		eString = eString + (e[i].nodeType!=ELEMENT_NODE ? e[i].nodeValue : android.selection.getElementString(e[i].childNodes));
	}
	return eString;
};

/**
 * private method
 * 
 * get the Node n's offset of Element e
 * return startOffset
 * 
 */

android.selection.getStartOffset = function(e,n){
	e = e.childNodes || e;
	for(var i=0; i<e.length; i++){
		if(e[i].nodeType == TEXT_NODE){
			if (e[i] == n)
				return;
			myStartOffset = myStartOffset + e[i].textContent.length;
		}
		else if(e[i].nodeType == ELEMENT_NODE){
			android.selection.getStartOffset(e[i],n);
		}
	}	
};

/**
 * private method
 *
 * get the Node n's offset of Element e
 * 
 * Note: we should count the Node n's length in!
 * return endOffset
 */

android.selection.getEndOffset = function(e,n){
	if(n.nodeType == ELEMENT_NODE){
		// it means we don't have to highlight any words in EndElement here
		myEndOffset = -1;
	}
	e = e.childNodes || e;
	for(var i=0; i<e.length; i++){
		if(e[i].nodeType == TEXT_NODE){
			if (e[i] == n){
				myEndOffset = myEndOffset + n.nodeValue.length;
				return;
			}
			myEndOffset = myEndOffset + e[i].textContent.length;
		}
		else if(e[i].nodeType == ELEMENT_NODE){
			android.selection.getEndOffset(e[i],n);
		}
	}	
};


/**
 * public method
 * the main entry of high light
 * */

android.selection.hlPaintAllOccurencesOfString = function(startElementTextLength, jsonText, startOffset) {
	hlStartOffset = startOffset;
	hlStartElementLen = startElementTextLength;
	hlEndOffset = jsonText.keyword.length + startOffset - 1;
	hlKeyword = jsonText.keyword;
	
	hlCurOffset = 0;
	
	android.selection.hlGetStartElement(document.body);
	
	//alert(startElement.nodeType + ":" + startElement.nodeName + ":" + startElement.nodeValue);
	//window.TextSelection.setLog(startElement.nodeType + ":" + startElement.nodeName + ":" + startElement.nodeValue);
	android.selection.hlPaintStartKeywordOfStartElement(hlStartElement);
};


/**
 * private method
 * get the start element
 * 
 * */
android.selection.hlGetStartElement = function(e) {
	if (e.nodeType == ELEMENT_NODE) {
		if (e.nodeName.toUpperCase() != "BODY" && e.nodeName.toUpperCase() != "HEAD") {
			var eString = android.selection.getElementString(e);
			//window.TextSelection.setLog(eString.length + ":" +  hlStartElementLen + "+" + eString);
			//window.TextSelection.setLog(eString.indexOf(hlKeyword) + ":" +  hlStartOffset);
			if (eString.length == hlStartElementLen && eString.indexOf(hlKeyword) == hlStartOffset) {
				//alert( e.nodeType  + ":"+ e.nodeValue +":" + e.nodeName);
				hlStartElement = e;
				return;
			}
		}
		
		// continue , until we get the target Element
		for(var i = 0; i < e.childNodes.length; i++)
			android.selection.hlGetStartElement(e.childNodes[i]);
	}
	else if (e.nodeType == TEXT_NODE) {
		// do nothing here
	}
};

/**
 * private method
 * do the high light jobs
 * 
 * */

android.selection.hlPaintStartKeywordOfStartElement = function(e) {
	if (hlCurOffset > hlEndOffset) {
		return;
	}
	var curOffset = hlCurOffset;// in case of curOffset change, although it may not!
	var span = document.createElement("span");
	span.setAttribute("class", "SocialHighLight");
	span.style.backgroundColor = "#ffcc99";
	span.style.color = "#663300";
	
	if (e.nodeType == ELEMENT_NODE) {
		for(var i = 0; i < e.childNodes.length; i++) {
			android.selection.hlPaintStartKeywordOfStartElement(e.childNodes[i]);
		}
	}
	else if (e.nodeType == TEXT_NODE) {
		var value = e.nodeValue;
		var eMaxOffset = e.nodeValue.length + hlCurOffset - 1; // the end of <e> 's offset position
		
		if (eMaxOffset < hlStartOffset) {
			hlCurOffset = eMaxOffset + 1; // plus 1, pointer to the next node start position
		}
		else if (eMaxOffset >= hlStartOffset && curOffset <= hlEndOffset) {
			if (eMaxOffset <= hlEndOffset) { 
				var begin = curOffset > hlStartOffset ? 0 : hlStartOffset - curOffset;
				var len = e.nodeValue.length - begin;
				var text = document.createTextNode(value.substr(begin, len));
				span.appendChild(text);
				
				e.deleteData(begin, len);
				
				var next = e.nextSibling;
				e.parentNode.insertBefore(span, next);
				
				hlCurOffset = eMaxOffset + 1;
			}
			else if (eMaxOffset > hlEndOffset) {
				var begin = curOffset > hlStartOffset ? 0 : hlStartOffset - curOffset;
				var len = e.nodeValue.length - (eMaxOffset - hlEndOffset) - begin;
				
				var text = document.createTextNode(value.substr(begin, len));
				span.appendChild(text);
				
				var rText = document.createTextNode(value.substr(begin + len, e.nodeValue.length - begin - len));
				
				e.deleteData(begin, e.nodeValue.length - begin);
				
				var next = e.nextSibling;
				
				e.parentNode.insertBefore(span, next);
				e.parentNode.insertBefore(rText, next);
				hlCurOffset = eMaxOffset + 1;
			}
		}
		
	}
};


android.selection.setDisplayArguments = function() {
	window.TextSelection.setDisplayArguments(document.width, document.height);
};

android.selection.setFontColorToWhite = function() {
	var p = document.getElementsByTagName('body');
	p[0].style.color = "#3d3d3d";
};


android.selection.shareText = function() {

	var title = document.getElementsByTagName('title');
	try {
		window.TextSelection.setShareContent(title[0].innerHTML, window.getSelection().toString());
	}
	catch(err) {
		window.TextSelection.setShareContent(null, window.getSelection().toString());
	}
};

android.selection.removeSpaces = function() {
    
    var p = document.getElementsByTagName('p');
    for(var i = 0; i < p.length; i++)
    {
        var content =p[i].innerHTML;
        p[i].innerHTML = android.selection.trimStr(content);
        //window.TextSelection.setLog(p[i].innerHTML);
    }
};

android.selection.trimStr = function(str) {
    //var re = /\s*(\S[^\0]*\S)\s*/;
    //re.exec(str);
    //return RegExp.$1;
    return str.replace(/^\s+|\s+$/, '');
};

// default
android.selection.changeColorToGrown = function() {
	var p = document.getElementsByTagName('body');
    //    p[0].style.background = "black";
	p[0].style.color = "#000000";
    //alert("yellow");
};


// yellow

android.selection.changeColor = function() {
    var p = document.getElementsByTagName('body');
	p[0].style.color = "#735839";
	//alert("default");
    
};
// night mode
android.selection.changeColorToWhite = function() {
	var p = document.getElementsByTagName('body');
    //	p[0].style.background = "white";
	p[0].style.color = "#ffffff";
	//alert("night");
};


// just for test , may be delete oneday
android.selection.copy = function() {
	alert(window.getSelection().toString());

};


android.selection.myTest = function(json) {
	alert(json.keyword);
};


// change font size

android.selection.changeFontSize = function(fontSize) { 
    var p = document.getElementsByTagName('p');
    for(var i = 0; i < p.length; i++)
    {
        //window.TextSelection.setLog(p[i].className);
        if(p[i].className.length == 0 || p[i].className == "edit"){
        	if (p[i].className == "edit") {
        		p[i].style.fontSize = (fontSize + 1) + "px";
        	}
            else {
            	p[i].style.fontSize = fontSize + "px";
            }
        }
        
    }
};

// change wechat font size


android.selection.changeWeChatFontSize = function(fontSize) {
    
    var p = document.getElementsByTagName('p');
    for(var i = 0; i < p.length; i++)
    {
        
        if(p[i].className.length == 0){
            p[i].style.fontSize = fontSize+"px";
        }
        
    }
    
    var span = document.getElementsByTagName('span');
    for(var i = 0; i < span.length;i++)
    {
        span[i].style.fontSize = fontSize+"px";
    }
    
    var div = document.getElementsByTagName('div');
    for(var i = 0; i < div.length; i++)
    {
        div[i].style.fontSize = fontSize+"px";
    }

};


android.selection.shareArticle = function() {
	var h2 = document.getElementsByTagName('h2');
	var p = document.getElementsByTagName('p');
	for (var i = 0; i < p.length; i++) {
		if(p[i].className == "edit"){
			window.TextSelection.setShareArticle(h2[0].innerHTML, p[i].innerHTML);
			break;
		}
	}
};

android.selection.showMoreMark = function() {
	
	/*var div = document.getElementsByTagName("div");
	
	var markCount = 0;
	
	for (var i = 0; i < div.length; i++) {
		if (div[i].className == "mark") {
			markCount++;
		}
	}*/
	
	window.TextSelection.loadMoreMarkFromServer();
};

android.selection.addNewMark = function(markJson) {
	
	// remove all mark
	
	var div = document.getElementsByTagName("div");
	for (var i = 0; i < div.length; i++) {
		if (div[i].className == "mark") {
			android.selection.removeMarks(div[i]);
			break;
		}
	}
	
	for (var i = 0; i < markJson.length; i++) {
		//alert(markJson[i].mark + "test");
		//alert(markJson[i].marktime);
		var newMarkNode = document.createElement("div");
		newMarkNode.setAttribute("class","mark");
		// 1
		var markChildNode = document.createElement("div");

		var markTextNode = document.createTextNode(markJson[i].mark);
		markChildNode.appendChild(markTextNode);
	
		newMarkNode.appendChild(markChildNode);
	
		// 2
		var brNode = document.createElement("br");
	
		newMarkNode.appendChild(brNode);
		// 3
		var markTimeChildNode = document.createElement("div");
	
		markTimeChildNode.setAttribute("class","markleft");
	
		var markTimeTextNode = document.createTextNode(markJson[i].marktime);
		markTimeChildNode.appendChild(markTimeTextNode);
	
		newMarkNode.appendChild(markTimeChildNode);
	
		// add to 
		
		var startHr = document.getElementById("markstart");
		var nextElement = startHr.nextSibling;
		
	
		var parent = nextElement.parentNode;
	
		parent.insertBefore(newMarkNode, nextElement);
	}
};


// remove all mark at the current
android.selection.removeMarks = function(e) {
	var tmp;
	var parent;
	while(true) {
		if (e.tagName == "p" || e.tagName == "P") {
			break;
		}
		
		tmp = e;
		parent = e.parentNode;
		e = e.nextSibling;
		
		parent.removeChild(tmp);
		
		//alert(tmp.tagName);
	}
};

android.selection.viewMore = function() {
	window.TextSelection.viewMore();
};

// soft space, not hard space which use text-intents
android.selection.removeSpaces = function() {
    
    var p = document.getElementsByTagName('p');
    for(var i = 0; i < p.length; i++)
    {
        var content =p[i].innerHTML;
        p[i].innerHTML = android.selection.trimStr(content);
    }
};

android.selection.trimStr = function(str) {
    return str.replace(/^\s+|\s+$/, '');
};
